#pragma once

#include "GeometryNode.h"

#include <memory>

class RectangleNode : public GeometryNode
{
public:
    RectangleNode(const Point& loc, double width, double height);
    static std::unique_ptr<RectangleNode> Create(const Point& loc, double width, double height);
    GeometryNode::Type getType() override;

    double getWidth() const;
    double getHeight() const;

    SceneItem* getSceneItem(std::size_t idx) const override;
    std::size_t getNumSceneItems() const override;

    void setWidth(double width);
    void setHeight(double height);

    void update(SceneInfo* sceneInfo) override;
private:
    double mWidth{1};
    double mHeight{1};

    std::unique_ptr<SceneModel> mBackgroundItem;
    std::unique_ptr<SceneModel> mOutlineItem;
};

using RectangleNodePtr = std::unique_ptr<RectangleNode>;


